<template>
  <div class="card container">
    <div class="container">
      <h1 class="text-black">Ajustes de cuenta</h1>

      <!-- Formulario para cambiar contraseña -->
      <form @submit.prevent="changePassword" class="mb-4">
        <h2 class="text-white">Cambiar contraseña</h2>
        <div class="form-group mb-4">
          <label for="currentPassword" class="text-black">Contraseña actual:</label>
          <input type="password" id="currentPassword" v-model="currentPassword" class="form-control form-control-sm" required>
        </div>
        <div class="form-group mb-4">
          <label for="newPassword" class="text-black">Nueva contraseña:</label>
          <input type="password" id="newPassword" v-model="newPassword" class="form-control form-control-sm" required>
          <div class="invalid-feedback" v-if="newPassword.length < 8">La contraseña debe tener al menos 8 caracteres.</div>
        </div>
        <div class="form-group mb-4">
          <label for="confirmPassword" class="text-black">Confirmar contraseña:</label>
          <input type="password" id="confirmPassword" v-model="confirmPassword" class="form-control form-control-sm" required>
          <div class="error-message" v-if="newPassword !== confirmPassword">Las contraseñas no coinciden</div>
        </div>
        <div class="form-group">
          <button type="submit" class="btn btn-primary">Cambiar contraseña</button>
        </div>
      </form>

      <!-- Opción para eliminar cuenta -->
      <div class="mt-5">
        <h2 class="text-black">Eliminar cuenta</h2>
        <button @click="confirmDelete" class="btn btn-danger">Eliminar cuenta</button>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'CuentasAjustesView',
  data() {
    return {
      currentPassword: '',
      newPassword: '',
      confirmPassword: '',
    };
  },
  methods: {
    changePassword() {
      if (this.newPassword !== this.confirmPassword) {
        alert('Las contraseñas no coinciden');
        return;
      }

      if (this.newPassword.length < 8) {
        alert('La contraseña debe tener al menos 8 caracteres.');
        return;
      }

      const passwordData = {
        contrasenaActual: this.currentPassword,
        nuevaContrasena: this.newPassword,
      };


      axios.put('http://localhost:3001/usuarios/cambiar-contrasena', passwordData)
        .then(() => {
          this.currentPassword = '';
          this.newPassword = '';
          this.confirmPassword = '';
          alert('Contraseña cambiada exitosamente');
          axios.defaults.headers.common['Authorization'] = '';
          localStorage.clear();
          this.$router.push('/login');
        })
        .catch(error => {
          console.error(error);
          if (error.response && error.response.data) {
            alert(error.response.data);
          } else {
            alert('Ocurrió un error al cambiar la contraseña');
          }
        });
    },
    confirmDelete() {
      if (window.confirm('¿Estás seguro de que quieres eliminar tu cuenta? Esta acción no puede deshacerse.')) {
        this.deleteAccount();
      }
    },
    deleteAccount() {
      axios.post('http://localhost:3001/usuarios/solicitar-eliminacion')
        .then(response => {
          alert(response.data);
          this.$router.push('/login');
        })
        .catch(error => {
          console.error(error);
          alert('Ocurrió un error al solicitar la eliminación de la cuenta');
        });
    }
  },
};
</script>

<style scoped>
.container {
  margin-top: 50px;
  margin-bottom: 50px;
  max-width: 400px;
}

.form-group {
  margin-bottom: 20px;
}

.text-white {
  color: white;
}
</style>
